HDU 2639 Bone Collector II (第k优解)

Bone Collector II

题目链接

Time Limit: 5000/2000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 5246 Accepted Submission(s): 2778

Problem Description
The title of this problem is familiar,isn’t it?yeah,if you had took part in the “Rookie Cup” competition,you must have seem this title.If you haven’t seen it before,it doesn’t matter,I will give you a link:

Here is the link:http://acm.hdu.edu.cn/showproblem.php?pid=2602

Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.

If the total number of different values is less than K,just ouput 0.

Input
The first line contain a integer T , the number of cases.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.

Output
One integer per line representing the K-th maximum of the total value (this number will be less than 231).

Sample Input
3
5 10 2
1 2 3 4 5
5 4 3 2 1
5 10 12
1 2 3 4 5
5 4 3 2 1
5 10 16
1 2 3 4 5
5 4 3 2 1


Sample Output
12
2
0


Author
teddy


Source
百万秦关终属楚

对于求次优解、第K优解类的问题,如果相应的最优解问题能写出状态转移方程、用动态规划解决,那么求次优解往往可以相同的复杂度解决,第K优解则比求最优解的复杂度上多一个系数K。
其基本思想是将每个状态都表示成有序队列,将状态转移方程中的max/min转化成有序队列的合并。这里仍然以01背包为例讲解一下。
首先看01背包求最优解的状态转移方程:f[i][v]=max{f[i-1][v],f[i-1][v-c[i]]+w[i]}。如果要求第K优解,那么状态f[i][v]就应该是一个大小为K的数组f[i][v][1..K]。其中f[i][v][k]表示前i个物品、背包大小为v时,第k优解的值。“f[i][v]是一个大小为K的数组”这一句,熟悉C语言的同学可能比较好理解,或者也可以简单地理解为在原来的方程中加了一维。显然f[i][v][1..K]这K个数是由大到小排列的,所以我们把它认为是一个有序队列。
然后原方程就可以解释为:f[i][v]这个有序队列是由f[i-1][v]和f[i-1][v-c[i]]+w[i]这两个有序队列合并得到的。有序队列f[i-1][v]即f[i-1][v][1..K],f[i-1][v-c[i]]+w[i]则理解为在f[i-1][v-c[i]][1..K]的每个数上加上w[i]后得到的有序队列。合并这两个有序队列并将结果(的前K项)储存到f[i][v][1..K]中的复杂度是O(K)。最后的答案是f[N][V][K]。总的复杂度是O(NVK)。

为什么这个方法正确呢?实际上,一个正确的状态转移方程的求解过程遍历了所有可用的策略,也就覆盖了问题的所有方案。只不过由于是求最优解,所以其它在任何一个策略上达不到最优的方案都被忽略了。如果把每个状态表示成一个大小为K的数组,并在这个数组中有序的保存该状态可取到的前K个最优值。那么,对于任两个状态的max运算等价于两个由大到小的有序队列的合并。
另外还要注意题目对于“第K优解”的定义,将策略不同但权值相同的两个方案是看作同一个解还是不同的解。如果是前者,则维护有序队列时要保证队列里的数没有重复的。


/*题意:给出N,V,K、 分别代表 物品的数量,背包的体积和满足条件的第K个大的值、  接下来两行分别有N个数字,分别代表着每个的价值,和体积、 最后求出第K个大的值为多少。*/
#include<algorithm>
#include<cstdio>
#include<cstring>
#include<iostream>
using namespace std;
int main()
{
    int  t;
    scanf("%d",&t);
    while(t--)
    {
        int dp[1010][50],va[1010],vv[1010],a[50],b[50];
        int n,v,k;
        scanf("%d%d%d",&n,&v,&k);
        for(int i=0;i<n;i++) scanf("%d",&va[i]);
        for(int i=0;i<n;i++) scanf("%d",&vv[i]);
        memset(dp,0,sizeof(dp));
        int x,y,z;
        for(int i=0;i<n;i++)
        {
            for(int j=v;j>=vv[i];j--)
            {
                int kk;
                for(kk=1;kk<=k;kk++)
                {
                    a[kk]=dp[j-vv[i]][kk]+va[i];
                    b[kk]=dp[j][kk];
                }
                a[kk]=-1;
                b[kk]=-1;
                x=y=z=1;
                while(z<=k&&(a[x]!=-1||b[y]!=-1))
                {
                    if(a[x]>b[y])
                        dp[j][z]=a[x++];
                    else
                        dp[j][z]=b[y++];
                    if(dp[j][z]!=dp[j][z-1])
                        z++;
                }
            }
        }
        printf("%d
",dp[v][k]);
    }
    return 0;
}
原文地址:https://www.cnblogs.com/nanfenggu/p/7899993.html